Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr
Class BooleanExpression

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.BinaryExpression
              net.sf.saxon.expr.BooleanExpression

All Implemented Interfaces:
  Serializable, SourceLocator, LocationProvider, SaxonLocator, Negatable, InstructionInfo, Locator

Direct Known Subclasses:
  AndExpression, OrExpression

    public abstract class BooleanExpression

extends BinaryExpression
implements Negatable

Boolean expression: two truth values combined using AND or OR.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.BinaryExpression
`operand0, operand1, operator`

Fields inherited from class net.sf.saxon.expr.Expression
`EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, EVENT_FEED_METHOD, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, PROCESS_METHOD, PUSH_SELECTION, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, WATCH_METHOD`

Constructor Summary
`BooleanExpression(Expression p1, int operator, Expression p2)` Construct a boolean expression

Method Summary
`int` | `computeCardinality()` Determine the static cardinality.
`abstract boolean` | `effectiveBooleanValue(XPathContext c)` Evaluate as a boolean.
`Item` | `evaluateItem(XPathContext context)` Evaluate the expression
`protected Expression` | `forceToBoolean(Expression in, TypeHierarchy th)`
`String` | `getExpressionName()` Get a name identifying the kind of expression, in terms meaningful to a user.
`ItemType` | `getItemType(TypeHierarchy th)` Determine the data type of the expression
`boolean` | `isNegatable(ExpressionVisitor visitor)` Check whether this specific instance of the expression is negatable
`static void` | `listAndComponents(Expression exp, List list)` Construct a list containing the "anded" subexpressions of an expression: if the expression is (A and B and C), this returns (A, B, C).
`abstract Expression` | `negate()` Return the negation of this boolean expression, that is, an expression that returns true when this expression returns false, and vice versa
`Expression` | `optimize(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
`Expression` | `typeCheck(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Type-check the expression.

Methods inherited from class net.sf.saxon.expr.BinaryExpression
`computeSpecialProperties, displayOperator, equals, explain, explainExtraAttributes, getArguments, getOperands, getOperator, hashCode, isAssociative, isCommutative, isInverse, iterateSubExpressions, promote, replaceSubExpression, setFlattened, simplify, toString`

Methods inherited from class net.sf.saxon.expr.Expression
`addToPathMap, adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeStaticProperties, copy, doPromotion, dynamicError, evaluateAsString, evaluatePendingUpdates, explain, getCardinality, getColumnNumber, getColumnNumber, getConstructType, getContainer, getDependencies, getEvaluationMethod, getExecutable, getHostLanguage, getImplementationMethod, getIntegerBounds, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, getSystemId, hasLoopingSubexpression, hasVariableBinding, implementsStaticTypeCheck, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, iterate, iterateEvents, iterateSameFocusSubExpressions, markTailFunctionCalls, process, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setLocationId, staticTypeCheck, suppressValidation, typeError`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### BooleanExpression

    public BooleanExpression(Expression p1,
                             int operator,
                             Expression p2)

  Construct a boolean expression

  Parameters:
    `p1` - the first operand
    `operator` - one of `Token.AND` or `Token.OR`
    `p2` - the second operand

Method Detail

### getExpressionName

    public String getExpressionName()

  Get a name identifying the kind of expression, in terms meaningful to a user.

  Overrides:
    `getExpressionName` in class `Expression`
  Returns:
    a name identifying the kind of expression, in terms meaningful to a user. The name will always be in the form of a lexical XML QName, and should match the name used in explain() output displaying the expression.

### typeCheck

    public Expression typeCheck(ExpressionVisitor visitor,
                                ExpressionVisitor.ContextItemType contextItemType)
                         throws XPathException

  Description copied from class: `BinaryExpression`
  Type-check the expression. Default implementation for binary operators that accept any kind of operand

  Overrides:
    `typeCheck` in class `BinaryExpression`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### computeCardinality

    public int computeCardinality()

  Determine the static cardinality. Returns [1..1]

  Overrides:
    `computeCardinality` in class `BinaryExpression`
  Returns:
    the computed cardinality, as one of the values `StaticProperty.ALLOWS_ZERO_OR_ONE`, `StaticProperty.EXACTLY_ONE`, `StaticProperty.ALLOWS_ONE_OR_MORE`, `StaticProperty.ALLOWS_ZERO_OR_MORE`

### optimize

    public Expression optimize(ExpressionVisitor visitor,
                               ExpressionVisitor.ContextItemType contextItemType)
                        throws XPathException

  Perform optimisation of an expression and its subexpressions.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

  Overrides:
    `optimize` in class `BinaryExpression`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### forceToBoolean

    protected Expression forceToBoolean(Expression in,
                                        TypeHierarchy th)

### isNegatable

    public boolean isNegatable(ExpressionVisitor visitor)

  Check whether this specific instance of the expression is negatable

  Specified by:
    `isNegatable` in interface `Negatable`
  Returns:
    true if it is

### negate

    public abstract Expression negate()

  Return the negation of this boolean expression, that is, an expression that returns true when this expression returns false, and vice versa

  Specified by:
    `negate` in interface `Negatable`
  Returns:
    the negation of this expression

### evaluateItem

    public Item evaluateItem(XPathContext context)
                      throws XPathException

  Evaluate the expression

  Overrides:
    `evaluateItem` in class `Expression`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### effectiveBooleanValue

    public abstract boolean effectiveBooleanValue(XPathContext c)
                                           throws XPathException

  Evaluate as a boolean.

  Overrides:
    `effectiveBooleanValue` in class `Expression`
  Parameters:
    `c` - The context in which the expression is to be evaluated
  Returns:
    the effective boolean value
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Determine the data type of the expression

  Specified by:
    `getItemType` in class `Expression`
  Parameters:
    `th` - the type hierarchy cache
  Returns:
    BuiltInAtomicType.BOOLEAN

### listAndComponents

    public static void listAndComponents(Expression exp,
                                         List list)

  Construct a list containing the "anded" subexpressions of an expression: if the expression is (A and B and C), this returns (A, B, C).

  Parameters:
    `exp` - the expression to be decomposed
    `list` - the list to which the subexpressions are to be added.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.